import javax.microedition.lcdui.*;
import java.util.*;

public class ElementForm extends Form implements CommandListener { 
 midlet  browser;
 Displayable parent;
 XMLElement  elem;

 ElementForm (XMLElement elem, midlet browser, Displayable parent) { 
  super(elem.getName());
  this.browser = browser;
  this.elem = elem;
  this.parent = parent; 
  Vector attributes = elem.getAttributes();
  if (attributes != null) { 
   for (int i = 0, n = attributes.size(); i < n; i++) { 
    XMLAttribute attr = (XMLAttribute)attributes.elementAt(i);
    if (attr.getName().equals(browser.locale.getResource("Image"))) { 
     String imagePath = attr.getValue();
     if (!imagePath.startsWith("/")) { 
      imagePath = "/" + imagePath;
     }
     try {                         
      Image image = Image.createImage(imagePath);
      append(new ImageItem(null, image, ImageItem.LAYOUT_NEWLINE_BEFORE|ImageItem.LAYOUT_NEWLINE_AFTER, null));
     } 
     catch (Exception x) {}
    } 
    else { 
     append(new StringItem(attr.getName(), attr.getValue()));
     append(new ImageItem (null,Image.createImage(128,1),ImageItem.LAYOUT_NEWLINE_BEFORE|ImageItem.LAYOUT_NEWLINE_AFTER, null));
     //  , ..  getWidth()   MIDP 2.0;    
    }
   }
  }
  String value = elem.getValue();
  if (value != null) { 
   append(new StringItem(null, value));
  }
  setCommandListener(this);
  if (elem.getItems() != null) { 
   addCommand(browser.SEARCH_CMD);
   addCommand(browser.DETAILS_CMD);
  }
  if (parent != null) { addCommand(browser.BACK_CMD); } 
  else { addCommand(browser.QUIT_CMD); }
  Display.getDisplay(browser).setCurrent(this);
 }

 public void commandAction(Command c, Displayable d) { 
  if (c == browser.SEARCH_CMD) { 
   new SearchBox(elem, browser, this);
  } 
  else if (c == browser.DETAILS_CMD) { 
   new ElementList(elem, browser, this);
  } 
  else if (c == browser.BACK_CMD) { 
   Display.getDisplay(browser).setCurrent(parent);
  } 
  else if (c == browser.QUIT_CMD) { 
   browser.quit();
  }
 }

}